package edu.kit.ipd.descartes.adaptation;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertTrue;

import org.junit.Before;
import org.junit.Test;

import edu.kit.ipd.descartes.mm.adaptation.AdaptationFactory;
import edu.kit.ipd.descartes.mm.adaptation.WeightedTactic;

public class TacticsHistoryTest {

	TacticsHistory hist = null;
	WeightedTactic w = null;
	static String TEST_ID = "TestId";
	
	@Before
	public void setUp() throws Exception {
		hist = TacticsHistory.getInstance();
		w = AdaptationFactory.eINSTANCE.createWeightedTactic();
	}

	@Test
	public void testAdd() {
		hist.add(w, TEST_ID, false);
		assertTrue(hist.size() == 1);
		assertEquals(w, hist.getLatestAppliedTactic());
		assertEquals(TEST_ID, hist.getLatestResultId());
		assertEquals(false, hist.wasLatestTacticSuccessful());
	}
}
