package edu.kit.ipd.descartes.adaptation.model.dmm.util;

import static org.junit.Assert.assertTrue;

import java.util.Set;

import org.eclipse.emf.ecore.EObject;
import org.junit.Before;
import org.junit.Test;

import edu.kit.ipd.descartes.adaptation.AbstractTest;
import edu.kit.ipd.descartes.adaptation.model.dmm.util.OclEvaluationHelper;
import edu.kit.ipd.descartes.mm.resourcelandscape.ComputingInfrastructure;
import edu.kit.ipd.descartes.mm.resourcelandscape.DataCenter;
import edu.kit.ipd.descartes.mm.resourcelandscape.DistributedDataCenter;
import edu.kit.ipd.descartes.mm.resourcelandscape.ResourcelandscapeFactory;
import edu.kit.ipd.descartes.mm.resourcelandscape.ResourcelandscapePackage;
import edu.kit.ipd.descartes.mm.resourcelandscape.RuntimeEnvironment;

public class OclEvaluationHelperTest extends AbstractTest {

    @Before
    public void setUp() throws Exception {
        super.setUp();
    }

    @Test
    public void testQueryForRuntimeEnvironments() {
        DistributedDataCenter testDdc = ResourcelandscapeFactory.eINSTANCE.createDistributedDataCenter();
        
        String queryExpression = "RuntimeEnvironment.allInstances()";
        Set<EObject> res = OclEvaluationHelper.query(testDdc, queryExpression, testDdc.eClass());
        assertTrue(res.size() == 0);
        
        DataCenter dc1 = ResourcelandscapeFactory.eINSTANCE.createDataCenter();
        testDdc.getConsistsOf().add(dc1);
        
        ComputingInfrastructure ci1 = ResourcelandscapeFactory.eINSTANCE.createComputingInfrastructure();
        dc1.getContains().add(ci1);
        
        RuntimeEnvironment re1 = ResourcelandscapeFactory.eINSTANCE.createRuntimeEnvironment();
        RuntimeEnvironment re2 = ResourcelandscapeFactory.eINSTANCE.createRuntimeEnvironment();
        ci1.getContains().add(re1);
        ci1.getContains().add(re2);
        
        res = OclEvaluationHelper.query(testDdc, queryExpression, ResourcelandscapePackage.eINSTANCE.getDistributedDataCenter());
        assertTrue(res.size() == 2);
    }
}
